#include <bits/stdc++.h>
using namespace std;

typedef int bbbb;
#define int unsigned int

struct Point
{
	int x, y;
	
	int Dist2 ( const Point & p ) const
	{
		return (x - p.x)*(x - p.x) + (y - p.y)*(y - p.y);
	}
	
	double Dist ( const Point & p ) const
	{
		return sqrt( Dist2( p ) );
	}
	
	static double Angle ( const Point & a, const Point & b, const Point & p )
	{
		double ux = 1.0*a.x - 1.0*p.x;
		double uy = 1.0*a.y - 1.0*p.y;
		double vx = 1.0*b.x - 1.0*p.x;
		double vy = 1.0*b.y - 1.0*p.y;
		return acos( (ux*vx + uy*vy) / sqrt( (ux*ux + uy*uy) * (vx*vx + vy*vy) ) );
	} 
	
	static int Cross ( const Point & p, const Point & q, const Point & r )
	{
		return (r.x - q.x)*(p.y - q.y) - (r.y - q.y)*(p.x - q.x);
	}
	static bool CCW ( const Point & p, const Point q, const Point & r )
	{
		return Cross( p, q, r ) > 0; 
	}
	static bool Collinear ( const Point & p, const Point q, const Point & r )
	{
		return Cross( p, q, r ) == 0;
	}
	
	static double DistToLine ( const Point & A, const Point & B, const Point & p, Point * c )
	{
		double scale = (double)((p.x - A.x) * (B.x - A.x) + (p.y - A.y)*(B.y - A.y)) / ((B.x - A.x) * (B.x - A.x) + (B.y - A.y) * (B.y - A.y));
		c->x = A.x + scale * (B.x - A.x);
		c->y = A.y + scale * (B.y - A.y);
		return p.Dist( *c );
	}
	
};

Point p[ 10005 ];
int N;

Point pivot;

bool CompAngle ( const Point & a, const Point & b )
{
	if ( Point::Collinear( pivot, a, b ) )	return pivot.Dist( a ) < pivot.Dist( b );
	double d1x = a.x - pivot.x, d1y = a.y - pivot.y;
	double d2x = b.x - pivot.x, d2y = b.y - pivot.y;
	return ( atan2( d1y, d1x ) - atan2( d2y, d2x ) ) < 0;
}

vector< Point > ConvexHull ()
{
	int lowest = 0;
	for ( int i = 1; i < N; ++i )
		if ( p[ i ].y < p[ lowest ].y || (p[ i ].y == p[ lowest ].y && p[i].x > p[lowest].x )) lowest = i;
	swap( p[0], p[lowest] );
	
	Point pivot = p[0];
	sort( p, p + N, CompAngle );
	
	vector< Point > q;
	q.push_back( p[ N - 1 ] );
	q.push_back( p[0] );
	int i = 1;
	while ( i < N )
		if ( q.size() < 2 || Point::CCW( q[ q.size() - 2 ], q[ q.size() - 1 ], p[ i ] ) )
			q.push_back( p[ i++ ] );
		else
			q.pop_back();
	return q;
}

double angles[ 100005 ];

bbbb main() {
	while ( cin >> N) 
	{
		for ( int i = 0; i < N; ++i )
			cin >> p[ i ].x >> p[ i ].y;
		pivot.x = 0;
		pivot.y = 0;
	
		vector< Point > ch = ConvexHull();
		ch.pop_back();
		reverse( ch.begin(), ch.end() );
		
		/*
		printf( "\n" );
		for ( int i = 0; i < ch.size(); ++i )
			printf( "%d %d\n", ch[ i ].x, ch[ i ].y );
		printf( "\n" );
		*/
		
		angles[ 0 ] = 0.0;
		angles[ 1 ] = Point::Angle( ch[ 0 ], ch[ 1 ], ch[ 2 ] );
		
		double res = INFINITY;
		double minus = 0.0;
		
		int i =0, j = 2;
		while ( i < ch.size() )
		{
			while ( true )
			{
				angles[ j ] = angles[ (j - 1 + ch.size()) % ch.size() ] +
				Point::Angle( ch[ (j - 1 + ch.size()) % ch.size() ], ch[ j ], ch[ (j + 1) % ch.size() ] );

				int nj = (j + 1) % ch.size();
				int dj = ch[ i ].Dist( ch[ j ] );
				int dnj = ch[ i ].Dist( ch[ nj ] );
				if ( dnj > dj )
				{
					j = (j + 1) % ch.size();
				}
				else
					break;
			}
			
			Point p1;
			Point p2;
			{
				double best = -1.0;
				int bestID = -1;
			
				int left = (i + 2) % ch.size();
				int right = j;
				
				printf( "lr: %d %d\n", left, right );
				
				if ( left > right ) right += ch.size();
				while ( left <= right )
				{
					int curr = (left + right)/2;
					double a = angles[ (curr - 1 + ch.size()) % ch.size() ] - minus;		
					printf( "angles = %lf\n", angles[ (curr - 1 + ch.size()) % ch.size() ] );
					printf( "minus = %lf\n", minus );
					printf( "a = %lf\n", a );
					if ( a > best )
					{
						best = a;
						bestID = curr % ch.size();
					}
					
					if ( a > M_PI )
					{
						right = curr - 1 ;
					}
					else
					{	
						left = curr + 1;
					}
				}
			
				printf( "%d\n", bestID );
				assert( bestID >= 0 && bestID <= ch.size() );
				assert( i >= 0 && i < ch.size() );
				
				Point::DistToLine( ch[ i ], ch[ (i + 1) % ch.size() ], ch[ bestID ], &p1 );
				printf( "%d (%d %d)\n", bestID, p1.x, p1.y );
			}

			{
				double best = -1.0;
				int bestID = -1;
			
				int left = (i + 2) % ch.size();
				int right = j;
				if ( left > right ) right += ch.size();
				while ( left <= right )
				{
					int curr = (left + right)/2;
					double a = angles[ (curr - 1 + ch.size()) % ch.size() ] - minus;		
					if ( a > best )
					{
						best = a;
						bestID = curr % ch.size();
					}

					if ( a > M_PI )
					{
						right = curr - 1 ;
					}
					else
					{
						left = curr + 1;
					}
				}
			
				Point::DistToLine( ch[ i ], ch[ (i + 1) % ch.size() ], ch[ bestID ], &p2 );
				printf( "%d (%d %d)\n", bestID, p2.x, p2.y );
			}
			
			
			Point tmp;
			double maxDist1 = Point::DistToLine( ch[i], ch[ (i+1) % ch.size() ], ch[j], &tmp );
			double maxDist2 = max( ch[i].Dist( ch[ (i+1) % ch.size() ] ), p1.Dist( p2 ) );
			
			printf( "%lf %lf\n", maxDist1, maxDist2 );
			res = min( res, 2 * (maxDist1 + maxDist2) );

			minus += angles[ (i + 1) % ch.size() ];
			++i;
		}
		
		printf( "%.6lf\n", res );
	}
	
	return 0;
}
